Subject: Re: [PATCH 03/26] t1400: Pass a legitimate <newvalue> to update command

From: Junio C Hamano <[email-masked]>
Date: Tue, 11 Mar 2014 13:06:47 -0700

Michael Haggerty <[email-masked]> writes:

> It seems to me that "-z" input will nearly always be machine-generated,
> so there is not much reason to accept the empty string as shorthand for
> zeros.  So I think that my version of the rules, being simpler to
> explain, is a slight improvement.  But your version is already out in
> the wild, so backwards-compatibility is also a consideration, even
> though it is rather a fine point in a rather unlikely usage (why use
> update rather than delete to delete a reference?).
>
> I don't know.  I'm willing to rewrite the code to go back to your rules,
> or rewrite the documentation to describe my rules.
>
> Neutral bystanders *cough*Junio*cough*, what do you prefer?

I may be misremembering things, but your first sentence quoted above
was exactly my reaction while reviewing the original change, and I
might have even raised that as an issue myself, saying something
like "consistency across values is more important than type-saving
in a machine format".

Since nobody else were raising the issue back then, however, we are
stuck with the interface.  I am not against deprecating and removing
the support for it in the longer term, though.